# Servicios criptográficos

Los módulos descritos en este capítulo implementan varios algoritmos de naturaleza criptográfica. Están disponibles a discreción de la instalación. En sistema Unix, el módulo `crypt` también puede estar disponible. Aquí una descripción:

- `hashlib` — Hashes seguros y resúmenes de mensajes
  - Algoritmos de hash
  - Usage
  - Constructors
  - Attributes
  - Hash Objects
  - Resúmenes SHAKE de largo variable
  - Cifrado de archivos
  - Derivación de clave
  - BLAKE2
    - Creando objetos hash
    - Constantes
    - Ejemplos
      - Cifrado simple
      - Usar diferentes tamaños de resumen
      - Cifrado de clave
      - Cifrado aleatorio
      - Personalización
      - Modo de árbol
    - Créditos
- `hmac` — Hash con clave para autenticación de mensajes
- `secrets` — Genera números aleatorios seguros para trabajar con secretos criptográficos
  - Números aleatorios
  - Generando tokens
    - ¿Cuántos bytes deben tener los tokens?
  - Otras funciones
  - Recetas y mejores prácticas